/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package beatmusic;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.JFrame;

/**
 *
 * @author Vincent
 */
public class Event implements ActionListener, KeyListener{

	private Gui frame;
	private	long fTime;
	private	long lTime;
	private int count;
	
	private float BPM;
	private float BPM2;
	
	public Event(Gui src){
		frame = src;
		frame.tapButton.addActionListener(this);
		frame.tapButton.addKeyListener(this);
		fTime = 0;
		lTime = 0;
		count = 0;
		BPM = 0;
		BPM2 = 0;
	}
	
	private void bpmCalc(){
		long time = System.currentTimeMillis();
		if( fTime == 0 || (time - lTime) > 2000){
			fTime = time;
			count = 0;
		}
		lTime = time;
		float interval = (float)(time - fTime);
		count++;

		float BPM;

		if(interval == 0) BPM = 0;
		else BPM = ((float)count/(float)interval)*60000;
		
		
		
		if(Math.abs(BPM - this.BPM) < 3.0){
			BPM = (float)((this.BPM+this.BPM2+BPM)/3);
			this.BPM2 = this.BPM;
			this.BPM = BPM;
		}
		else this.BPM = BPM;

		frame.BPM.setText(Integer.toString(Math.round(this.BPM)));
		frame.MPM.setText(Integer.toString(Math.round((float)this.BPM/4)));
	}
	
	public void actionPerformed(ActionEvent e) {
		if( e.getActionCommand()=="tap"){
			this.bpmCalc();
		}
	}

	public void keyTyped(KeyEvent e) {
		if(e.getKeyCode() == 10 || e.getKeyCode() == 32){
			this.bpmCalc();
		}
	}

	public void keyPressed(KeyEvent e) {
		
	}

	public void keyReleased(KeyEvent e) {
		
	}

	
}
